########################################################################
#
# Copyright(c) 2006-2019 ThreatSTOP, Inc. All Rights Reserved
#
# NOTICE: All information contained herein is, and remains the property
# of ThreatSTOP, Inc. and its suppliers, if any. The intellectual and
# technical concepts contained herein are proprietary to ThreatSTOP, Inc.
# and its suppliers and certain aspects thereof are protected by United
# States Patent No. 8,533,822 and United States Patent No. 8,869,237,
# United States Patent No. 62539504 (Pending),
# and are protected by trade secret or copyright law.
#
# US Government Entities: The ThreatSTOP service, software and
# documentation, as applicable, are "commercial computer software" and
# "commercial computer software documentation" developed exclusively at
# private expense by Threatstop, Inc. ("Threatstop"). Pursuant to FAR
# 12.212 or DFARS 227 7202 and their successors, as applicable, use,
# reproduction and disclosure of the software and documentation is
# governed by the terms of Threatstop's commercial agreement.
#
########################################################################

# provides a hash
#
package ThreatStop::LocalTelemetry;
use strict;
use warnings;
use 5.010;    #enable perl 5.10 features.
use Exporter;

use Data::Dumper;

use lib "/opt/threatstop/lib/";
use lib "lib";
use ThreatStop;


# Standard Module defines

our @ISA       = qw(Exporter);
our @EXPORT    = qw($DEVICE_TELEMETRY device_telemetry);
our @EXPORT_OK = qw();

our $DEVICE_TELEMETRY   = {};

our $CFG;

my $err = '';
unless (keys %$CFG) {
    printMsg('INFO', "Loading config data");
    &loadConfFileData($ThreatStop::CONFIGFILE, $CFG, \$err);
    printMsg('DEBUG', 'CONFIG: ' . Dumper $CFG);
}

sub device_telemetry {
    my ($cfg) = @_;
    $cfg = $CFG unless $cfg;

    # expected to have $DEVICE_TELEMETRY->{PERSISTENT}->{key} = value
    if (exists $cfg->{tsprefix}) {
        # count block ips, allow ips and record them.
        &printMsg('DEBUG', "Counting block IPs");
        for my $list_type (qw(allow block)) {
            $DEVICE_TELEMETRY->{TRANSIENT}->{$list_type} = '0'; # default
            if (-f "/var/db/aliastables/ThreatSTOP_${list_type}.txt") {
                $DEVICE_TELEMETRY->{TRANSIENT}->{$list_type} = `$SUDO cat /var/db/aliastables/ThreatSTOP_${list_type}.txt|grep '^[0-9]'|wc -l|tr -d ' '`;
                chomp($DEVICE_TELEMETRY->{TRANSIENT}->{$list_type});
            }
        }
    }
    return $DEVICE_TELEMETRY;
}




1;    #End of module
