<?php
/**
 *
 * Copyright(c) 2006-2019 ThreatSTOP, Inc. All Rights Reserved
 *
 * NOTICE: All information contained herein is, and remains the property
 * of ThreatSTOP, Inc. and its suppliers, if any. The intellectual and
 * technical concepts contained herein are proprietary to ThreatSTOP, Inc.
 * and its suppliers and certain aspects thereof are protected by United
 * States Patent No. 8,533,822 and United States Patent No. 8,869,237,
 * and are protected by trade secret or copyright law.
 *
 * US Government Entities: The ThreatSTOP service, software and
 * documentation, as applicable, are "commercial computer software" and
 * "commercial computer software documentation" developed exclusively at
 * private expense by Threatstop, Inc. ("Threatstop"). Pursuant to FAR
 * 12.212 or DFARS 227 7202 and their successors, as applicable, use,
 * reproduction and disclosure of the software and documentation is
 * governed by the terms of Threatstop's commercial agreement.
 */

/*
pfSense_MODULE: aliases
 */

require "guiconfig.inc";
require_once "functions.inc";
require_once "filter.inc";
require_once "shaper.inc";

if (!is_array($config['aliases']['alias'])) {
  $config[aliases] = Array("alias" => Array());
}
// if (array_key_exists('aliases', $config[aliases])) {
//  echo "removing aliases => aliases";
//  unset($config[aliases][aliases]);
// }
foreach ($config['aliases']['alias'] as $key => $some_alias) {
  if (empty($some_alias)) {
    unset($config['aliases']['alias'][$key]);
  }
}

$a_aliases = &$config['aliases']['alias'];

if ($_POST) {

  $pconfig = $_POST;

  if ($_POST['apply']) {
    $retval = 0;

    /* reload all components that use aliases */
    $retval = filter_configure();

    if (stristr($retval, "error") != true) {
      $savemsg = get_std_save_message($retval);
    } else {
      $savemsg = $retval;
    }

    if ($retval == 0) {
      clear_subsystem_dirty('aliases');
    }

  }
}

if ($_GET['act'] == "del") {
  if ($a_aliases[$_GET['id']]) {
    /* make sure rule is not being referenced by any nat or filter rules */
    $is_alias_referenced = false;
    $referenced_by = false;
    $alias_name = $a_aliases[$_GET['id']]['name'];
    // Firewall rules
    find_alias_reference(array('filter', 'rule'), array('source', 'address'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('filter', 'rule'), array('destination', 'address'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('filter', 'rule'), array('source', 'port'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('filter', 'rule'), array('destination', 'port'), $alias_name, $is_alias_referenced, $referenced_by);
    // NAT Rules
    find_alias_reference(array('nat', 'rule'), array('source', 'address'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('nat', 'rule'), array('source', 'port'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('nat', 'rule'), array('destination', 'address'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('nat', 'rule'), array('destination', 'port'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('nat', 'rule'), array('target'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('nat', 'rule'), array('local-port'), $alias_name, $is_alias_referenced, $referenced_by);
    // NAT 1:1 Rules
    find_alias_reference(array('nat', 'onetoone'), array('destination', 'address'), $alias_name, $is_alias_referenced, $referenced_by);
    // NAT Outbound Rules
    find_alias_reference(array('nat', 'advancedoutbound', 'rule'), array('source', 'network'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('nat', 'advancedoutbound', 'rule'), array('sourceport'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('nat', 'advancedoutbound', 'rule'), array('destination', 'address'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('nat', 'advancedoutbound', 'rule'), array('dstport'), $alias_name, $is_alias_referenced, $referenced_by);
    find_alias_reference(array('nat', 'advancedoutbound', 'rule'), array('target'), $alias_name, $is_alias_referenced, $referenced_by);
    // Alias in an alias
    find_alias_reference(array('aliases', 'alias'), array('address'), $alias_name, $is_alias_referenced, $referenced_by);
    if ($is_alias_referenced == true) {
      $savemsg = sprintf(gettext("Cannot delete alias. Currently in use by %s"), $referenced_by);
    } else {
      unset($a_aliases[$_GET['id']]);
      write_config();
      filter_configure();
      mark_subsystem_dirty('aliases');
      header("Location: firewall_aliases.php");
      exit;
    }
  }
}

function find_alias_reference($section, $field, $origname, &$is_alias_referenced, &$referenced_by) {
  global $config;
  if (!$origname || $is_alias_referenced) {
    return;
  }

  $sectionref = &$config;
  foreach ($section as $sectionname) {
    if (is_array($sectionref) && isset($sectionref[$sectionname])) {
      $sectionref = &$sectionref[$sectionname];
    } else {
      return;
    }

  }

  if (is_array($sectionref)) {
    foreach ($sectionref as $itemkey => $item) {
      $fieldfound = true;
      $fieldref = &$sectionref[$itemkey];
      foreach ($field as $fieldname) {
        if (is_array($fieldref) && isset($fieldref[$fieldname])) {
          $fieldref = &$fieldref[$fieldname];
        } else {
          $fieldfound = false;
          break;
        }
      }
      if ($fieldfound && $fieldref == $origname) {
        $is_alias_referenced = true;
        if (is_array($item)) {
          $referenced_by = $item['descr'];
        }

        break;
      }
    }
  }
}

$pgtitle = array(gettext("ThreatSTOP"), gettext("Installation"));
include "head.inc";

?>

<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
<?php
/*
 * GS-905
 */
require "threatstop.conf.php";
if (($PF_VERSION_MAJOR == 2 && $PF_VERSION_MINOR <= 2) || ($PF_VERSION_MAJOR == 1)) {

  include "fbegin.inc";
}

?>
<?php
global $config;
$ts_enabled = false;

foreach ($config['filter']['rule'] as $some_rule) {

  if (strpos(strtolower($some_rule['descr']), 'threatstop') !== false) {
    $ts_enabled = true;
  }

}

$uninstall_button = '';

// if ($ts_enabled) {
//  $ts_status = "Enabled";
//  $tsactions = '<a href="tsdisable.php"><button>Disable</button></a>';
// } else {
//  $ts_status = "Disabled";
//  $tsactions = '<a href="tsenable.php"><button>Enable</button></a><a href="tsremove.php"><button>Remove ThreatSTOP</button></a>';
// }

$ts_errors = '';
if (file_exists("{$g['varrun_path']}/filter_reload_status")) {
  $ts_errors = file_get_contents("{$g['varrun_path']}/filter_reload_status");
}

?>
<?php echo '
<style>

#tslogo {
  width: 180px;
  margin-bottom: 25px;
}
#loginlink {
  float: right;
  font-size: 20px;
  margin-right: 30px;
}
#tsactions button {
  margin: 0px 20px;
}
#tsactions {
}
.bottomright {
    position:absolute; bottom:20px;  margin-bottom:7px; margin:7px; right: 20px;
}

.fixedheight {
    height: 450px; position: relative;
    // border: 1px solid;
}
.right-links {
   width: 300px;
   position: absolute;
   top: 30px; right: 20px;
}

.toggle-group {
    // width: 185% !important;
}
/*
#tsactions button {
  border-radius: 15px;
  font-size: 20px;
  margin-right: 15px;
  outline: none;
}
#tsactions button:hover {
  background-color: #bbb;
}
*/
span#tsactions div.toggle {
    width: 120px !important;
}

.panel p {
    margin: 8px 10px;
    font-size: 16px;
}

#ts_policy p {
    margin: 5px 10px;
    font-size: 14px;
}

#ts_nav {
    position: absolute;
    top: 50px;
    right: 100px;
    width: 300px;
    height: 100px;
}
#ts_nav h3 {
   font-size: 16px;
   margin: 2px 5px;
}

</style>
';
?>

<img src="/ts_logo_bw.png" id="tslogo" />



<!-- start -->

<?php
// get threatstop integration state
$ts_status = 'unknown';
if ($ts_enabled) {
  $ts_status = "Enabled";
} else {
  $ts_status = "Disabled";
}
// echo "ts_state: $ts_status\n";
// see if we have req'd js libs
$has_jquery = false;
$has_bootstrap = false;
$include_files = array("foot.inc", "fend.inc");
foreach ($include_files as $file) {
  if (!file_exists($file)) {
    // echo "$file does not exist";
    continue;
  }
  // echo "checking $file \n";
  if (strpos(file_get_contents($file), 'js/bootstrap') !== false) {
    // echo "Bootstrap located";
    $has_bootstrap = true;
  }
  if (strpos(file_get_contents($file), 'jquery') !== false) {
    // echo "jquery located";
    $has_jquery = true;
  }
}

?>

<div class="container">
    <div class="row">

 <!--      <div class="troubleshooting">
        <pre>
          <?//print_r($config);?>
        </pre>
      </div>
 -->

        <div id="tsstatus" class="jumbotron fixedheight">
             <div class="col-sm-4">
              <div class="panel panel-default">
                <div class="panel-heading">
                  <h3 class="panel-title">Integration Status <small style="float: right; margin-top: 5px;">v<?=$TS_CONFIG[device_environment_loaded];?></small></h3>
                </div>
                <div class="panel-body">
                 <p><?=$ts_status?></p>
                </div>
              </div>
              <div class="panel panel-default">
                <div class="panel-heading">
                  <h3 class="panel-title">Device ID</h3>
                </div>
                <div class="panel-body">
                  <p><?=$TDID ? $TDID : "Not Set"?></p>
                </div>
              </div>
              <!-- <div class="panel panel-default">
                <div class="panel-heading">
                  <h3 class="panel-title">Version</h3>
                </div>
                <div class="panel-body">
                 <p><?#=$TS_CONFIG[device_environment_loaded];?></p>
                </div>
              </div> -->
              <?

              function time_since($since) {
                    $chunks = array(
                        array(60 * 60 * 24 * 365 , 'year'),
                        array(60 * 60 * 24 * 30 , 'month'),
                        array(60 * 60 * 24 * 7, 'week'),
                        array(60 * 60 * 24 , 'day'),
                        array(60 * 60 , 'hour'),
                        array(60 , 'minute'),
                        array(1 , 'second')
                    );

                    for ($i = 0, $j = count($chunks); $i < $j; $i++) {
                        $seconds = $chunks[$i][0];
                        $name = $chunks[$i][1];
                        if (($count = floor($since / $seconds)) != 0) {
                            break;
                        }
                    }

                    $print = ($count == 1) ? '1 '.$name : "$count {$name}s";
                    return $print;
                }
                $tsdir = $TS_CONFIG[src] ? $TS_CONFIG[src] : '/opt/threatstop';
                $log_upload_color = 'default';
                $log_upload_status = 'has not uploaded yet';
                if ($TS_CONFIG[logupload] != 'enabled') {
                  $log_upload_status = 'disabled';
                }
                if (file_exists($tsdir . '/.log_upload_status')) {
                  $log_upload_status = trim(file_get_contents($tsdir . '/.log_upload_status'));
                  //testing $log_upload_status = 'failure';
                }
                if ($log_upload_status == "success") {
                  $log_upload_color = $log_upload_status;
                } elseif ($log_upload_status == 'failure') {
                  $log_upload_color = 'danger';
                }

                $policy_download_color = 'default';
                $policy_download_status = 'unknown';
                if (file_exists($tsdir . '/.policy_download_status')) {
                  $policy_download_status = trim(file_get_contents($tsdir . '/.policy_download_status'));
                }
                if ($policy_download_status == "success") {
                  $policy_download_color = $policy_download_status;
                } elseif ($policy_download_status == 'failure') {
                  $policy_download_color = 'danger';
                }
                // echo "final logupload status: $log_upload_status";
                ?>
              <div class="panel panel-<?=$policy_download_color;?>">
                <div class="panel-heading">
                  <h3 class="panel-title">Policy </h3>
                </div>
                <div class="panel-body" id="ts_policy">
                 <!-- <p><? //$file = $tsdir . '/.last_policy_update';if (file_exists($file)) {echo date("D, M j Y H:i.", filemtime($tsdir . '/.last_policy_update'));} else {echo '-';}?></p> -->
                 <p>Block: <?=$TS_CONFIG[block_list];?></p>
                 <p>Allow: <?=$TS_CONFIG[allow_list];?></p>
                 <p style="float: right; margin-top:-8px;">
                     <sub>Last Updated: <?$file = $tsdir . '/.last_policy_update';if (file_exists($file)) {echo time_since(date("U") - date("U", filemtime($tsdir . '/.last_policy_update'))) . ' ago';} else {echo '-';}?> </sub>
                 </p>
                </div>
              </div>
              <div class="panel panel-<?=$log_upload_color;?>">
                <div class="panel-heading">
                  <h3 class="panel-title">Last Log Upload Attempt </h3>
                </div>
                <div class="panel-body">
                    <p><? echo ucfirst($log_upload_status);?> <?$file = $tsdir . '/.last_log_upload_attempt';if (file_exists($file)) {echo time_since(date("U") - date("U", filemtime($file))) . ' ago';} else {echo '';}?></p>
                </div>
              </div>
            </div>
            <div id="ts_nav" class="panel panel-default">
                <div class="panel-heading">
                   <h3>Links</h3>
                </div>
                <div class="panel-body">
                    <div class="list-group">
                        <a target="threatstop" class="list-group-item" href="https://admin.threatstop.com/">ThreatSTOP Admin Portal</a>
                        <a target="threatstopdocs" class="list-group-item" href="https://docs.threatstop.com/pfsense2.html">ThreatSTOP pfsense Docs (CLI Integration)</a>
                        <a target="threatstopdocs" class="list-group-item" href="https://docs.threatstop.com/webauto_pfsense.html">ThreatSTOP pfsense Docs (Web Automation)</a>
                    </div>
                </div>
            </div>
          <span id="tsactions" class="bottomright">
            <?php if ($has_jquery and $has_bootstrap) {
  //<!-- ENABLE / DISABLE SLIDER -->
  $tsactions = '<input type="checkbox" id="ts_toggle" ' . ($ts_enabled ? "checked" : "") . ' data-offstyle="" data-size="large">';

  //<!-- REMOVE BUTTON -->
  $uninstall_button = '<a href="' . ($ts_enabled ? '#' : 'tsremove.php') . '" ><button type="button" class="btn btn-danger btn-lg ' . ($ts_enabled ? "disabled" : "") . '" > Remove ThreatSTOP</button></a>';

} else {
  // echo "Defaulting to old buttons";
  if ($ts_enabled) {
    $tsactions = '<a href="tsdisable.php"><button class="btn btn-danger btn-lg">Disable</button></a>';
  } else {
    $tsactions = '<a href="tsenable.php"><button class="btn btn-primary btn-lg">Enable</button></a><a href="tsremove.php"><button class="btn btn-danger btn-lg">Remove ThreatSTOP</button></a>';
  }
}
?>
            <?=$tsactions?>
            <?=$uninstall_button?>

          </span>


        <br/>

        </div> <!-- jumbotron -->




        <!-- end -->

        <?php if ($ts_errors and $ts_enabled) {
  ?>
        <br />
        <h3>Installation log</h3>
        <div id="status" name="status" class="well">
            <p>
                <?php echo str_replace("\n", "<br/>\n", $ts_errors); ?>
            </p>
        </div>
    </div>
</div>
<br />





</form><?php }?>
<?php

// Changed in 2.4
if (file_exists("foot.inc")) {
  include "foot.inc";
}
// <= 2.3
if (file_exists("fend.inc")) {
  include "fend.inc";
}

# add in script for slider
if ($has_jquery and $has_bootstrap) {
  echo '
    <link href="/bootstrap-toggle.min.css" rel="stylesheet">
    <script src="/bootstrap-toggle.min.js"></script>
    ';
}

?>

<script>
  $(document).ready(function() {
    console.log('loading slider menu');
    $('#ts_toggle').bootstrapToggle({
      on: 'Enabled',
      off: 'Disabled'
    });
    $('#ts_toggle').change(function() {
      console.log('Toggle: ' + $(this).prop('checked'))
      if ($(this).prop('checked') == true) {
          console.log('going to tsenable.php');
          window.location.href = 'tsenable.php';
      } else {
          console.log('going to tsdisable.php');
          window.location.href = 'tsdisable.php';
      }
      /* $('#console-event').html('Toggle: ' + $(this).prop('checked'))*/
    })
  });
</script>





</body>
</html>
